;
; AutoHotkey Version: 1.x
; Language:       English
; Platform:       WinXP
; Author:         Ian 
; Name:		   winpult
;
; Script Function:
;	Plugin for qatapult (http://www.donationcoder.com/forum/index.php?topic=29595.0)
;	shows, hides, maximises or miniseises windows based on HWD or title. 

#NoEnv ; Recommended for performance and compatibility with future AutoHotkey releases.
SendMode Input ; Recommended for new scripts due to its superior speed and reliability.

; set up list of allowed actions
ValidActions := "toggleontop,top,bottom,min,max,restore,close"
NumberOfArgs = %0%

; check we have at least 2 things. 
If (NumberOfArgs >= 2)
{
	; set the window and action 
	SelectedWindow = %1%
	SelectedAction = %2%
}
Else
{
	; we don't have two arguments. !!!!!! GRRRR$#@%% !!!!!!
	; error for the user 
	MsgBox, % "use: winpult.exe window.title, window.HWND "
          . "(" . ValidActions . ")."
          . "Please look at your plugin.xml and correct. Thanks."
	ExitApp
}

; check the action is something the script can work with 
If SelectedAction not in %ValidActions%
{
	; we don't recognise the action. !!!!!! GRRRR$#@%% !!!!!!
	; error for the user
	MsgBox, % """" . SelectedAction . """" 
          . "is not recognised. You can use "
          . """"  . ValidActions . """"
          . "Please look at your plugin.xml and correct. Thanks."
	ExitApp
}

; labels can be cases! work out what action to preform!
If IsLabel("case-" . SelectedAction) 	
{
	; get the windowid to work with 
	Window := GetWindowId(SelectedWindow)
	Loop 1
	{
		;Goto case-%SelectedAction%  
    Goto, % "case-" . SelectedAction

    case-toggleontop:
      WinSet, AlwaysOnTop, Toggle, % "ahk_id " . Window
			Break
      
		case-top:
			WinActivate, % "ahk_id " . Window
			Break
		
		case-bottom:
			WinSet, Bottom, , % "ahk_id " . Window
			Break
		
		case-min:
			WinMinimize, % "ahk_id " . Window
			Break

		case-max:
			WinMaximize, % "ahk_id " . Window
			Break

    case-restore:
      ;WinSet, Region, , % "ahk_id " . Window
      WinRestore, % "ahk_id " . Window
      Break
      
		case-close:
			WinClose, % "ahk_id " . Window
			Break			
	}
}
	
; this is a function to get the window ID. Can take HWND or title. 	
GetWindowId(SelectedWindow)
{
	; work out the window. We serve pie for HWND and Title!
	If SelectedWindow is integer
	{
		; assume HWND
		WinGet, HWD_ID, ID, % "ahk_id " . SelectedWindow
	}
	Else
	{
		; assume Title
		SetTitleMatchMode RegEx
		WinGet, HWD_ID, ID, % "i)" . SelectedWindow
	}
	Return HWD_ID
}
	